include gendll.e


global constant BMP_FLIP        =   4,
		BMP_DONT_FLIP   =   0,
		BMP_INVERT      =   5,
		BMP_DONT_INVERT =   0,
		BMP_HEADER      =   6,
		BMP_NO_HEADER   =   0,
		BMP_PALETTE     =   7,
		BMP_NO_PALETTE  =   0,
		BMP_ALIGN       =   8,
		BMP_DONT_ALIGN  =   0


atom lpzFName,lpBMPStruct1,lpBMPStruct2,beeampee
integer LoadBMP,SaveBMP,FreeBMP,ConfigBMP



global function init_beeampee()
	beeampee = open_dll("beeampee.dll")
	if beeampee<=0 then
		return 0
	end if

	LoadBMP = define_c_proc(beeampee, "LoadBMP", {C_POINTER, C_POINTER})	
	SaveBMP = define_c_func(beeampee, "SaveBMP", {C_POINTER, C_POINTER, C_POINTER}, C_INT)
	FreeBMP = define_c_proc(beeampee, "FreeBMP", {C_POINTER})
	ConfigBMP = define_c_proc(beeampee, "ConfigBMP", {C_INT, C_INT})
	
	lpzFName = allocate(256)
	lpBMPStruct1 = allocate(788*2)
	lpBMPStruct2 = lpBMPStruct1 + 788
	
	return 1
end function


global procedure uninit_beeampee()
	free(lpBMPStruct1)
	free(lpzFName)
	close_dll(beeampee)
end procedure



global function LoadBitmap(sequence s)
  	sequence bmp
  
  	poke(lpzFName, s&0)
  	c_proc(LoadBMP, {lpzFName,lpBMPStruct1})
  
   	bmp = peek4u({lpBMPStruct1,5}) & 0
   	bmp[6] = repeat(0,256)
   	for i=0 to 255 do
   		bmp[6][i+1] = peek({lpBMPStruct1+20+(i*3),3})
   	end for
   
   	return bmp
end function


global procedure FreeBitmap(sequence bmp)
  	poke4(lpBMPStruct1,bmp[1])
  	c_proc(FreeBMP, {lpBMPStruct1})
end procedure


global procedure config_beeampee(integer parmname,integer parmval)
	c_proc(ConfigBMP,{parmname,parmval})
end procedure


global function SaveBitmap(sequence fname, sequence bmp1, sequence bmp2)
	poke(lpzFName, fname&0)
	poke4(lpBMPStruct1,bmp1[1..5])
	poke4(lpBMPStruct2,bmp2[1..5])
	if length(bmp1[6]) then
		for i=0 to 255 do
			poke(lpBMPStruct1+20+(i*3),bmp1[6][i+1])
		end for
	end if
	if length(bmp2[6]) then
		for i=0 to 255 do
			poke(lpBMPStruct2+20+(i*3),bmp2[6][i+1])
		end for
	end if
	return c_func(SaveBMP, {lpzFName, lpBMPStruct1, lpBMPStruct2})
end function



