;######################## KERNEL32.DLL replacement ######################


; Compile with MASM:
;
;   ml /c /coff genknl32.asm
;
;   link /SUBSYSTEM:WINDOWS /DLL /DEF:genknl32.def /OUT:genknl32.dll genknl32.obj
;
;

    .386
    .model flat, stdcall
    option casemap :none   ; case sensitive


;#########################################################################

    include windows.inc
 
;#########################################################################

    szText MACRO Name, Text:VARARG
      LOCAL lbl
        jmp lbl
          Name db Text,0
        lbl:
      ENDM

    m2m MACRO M1, M2
      push M2
      pop  M1
    ENDM

    return MACRO arg
      mov eax, arg
      ret
    ENDM

;##########################################################################

.data

dummyString	db	'swizzlesticks',0,0,0,0


;##########################################################################

.code

LibMain PROC hInstDLL:DWORD, reason:DWORD, unused:DWORD


        .if reason == 1		;DLL_PROCESS_ATTACH

            return TRUE
            ; -----------------------------
            ; If error at startup, return 0
            ; System will abort loading DLL
            ; -----------------------------

        .elseif reason == 0	;DLL_PROCESS_DETACH

        .elseif reason == 2	;DLL_THREAD_ATTACH

        .elseif reason == 3	;DLL_THREAD_DETACH
            
        .endif

        return FALSE

LibMain ENDP

; ##########################################################################


CloseHandle PROC hObject:DWORD
	xor eax,eax
	ret
CloseHandle ENDP


CreateFileA PROC lpFileName:DWORD,dwDesiredAccess:DWORD,dwShareMode:DWORD,lpSecurityAttributes:DWORD,
                 dwCreationDistrobution:DWORD,dwFlagsAndAttributes:DWORD,hTemplateFile:DWORD

	xor eax,eax
	ret
CreateFileA ENDP


ExitProcess PROC uExitCode:DWORD
	mov eax,uExitCode
	ret
ExitProcess ENDP


GetCommandLineA PROC
	mov eax,OFFSET dummyString
	ret
GetCommandLineA ENDP


GetCurrentProcess PROC
	xor eax,eax
	ret
GetCurrentProcess ENDP


GetCurrentThreadId PROC
	xor eax,eax
	ret
GetCurrentThreadId ENDP


GetModuleFileNameA PROC hModule:DWORD,lpFileName:DWORD,nSize:DWORD
	push ecx
	mov ecx,14
	cmp nSize,14
	jge sizeOK
		mov ecx,nSize
	sizeOK:
	push esi
	push edi
	mov esi,OFFSET dummyString
	mov edi,lpFileName
	rep movsb
	pop edi
	pop esi
	pop ecx
	ret
GetModuleFileNameA ENDP


GetProcAddress PROC hModule:DWORD,lpProcName:DWORD
	xor eax,eax
	ret
GetProcAddress ENDP


GetStartupInfoA PROC lpStartupInfo:DWORD
	mov eax,lpStartupInfo
	push ebx
	xor ebx,ebx
	mov [eax],ebx
	mov [eax+4],ebx
	mov [eax+8],ebx
	mov [eax+12],ebx
	pop ebx
	ret
GetStartupInfoA ENDP


GetStdHandle PROC nStdHandle:DWORD
	mov eax,INVALID_HANDLE_VALUE
	ret
GetStdHandle ENDP


GetVersion PROC
	mov eax,0104h			; Make the caller belive this is Win95 (4.1)
	ret
GetVersion ENDP


LoadLibraryA PROC lpLibFileName:DWORD
	xor eax,eax
	ret
LoadLibraryA ENDP


LoadLibraryEx PROC lpLibFileName:DWORD,hFile:DWORD,dwFlags:DWORD
	xor eax,eax
	ret
LoadLibraryEx ENDP


MultiByteToWideChar PROC CodePage:DWORD,dwFlags:DWORD,lpWideCharString:DWORD,cchWideChar:DWORD,
		         lpMultiByteString:DWORD,cchMultiByte:DWORD,lpDefaultChar:DWORD,lpUsedDefaultChar:DWORD
	xor eax,eax
	ret
MultiByteToWideChar ENDP


TerminateProcess PROC hProcess:DWORD,uExitCode:DWORD
	xor eax,eax
	ret
TerminateProcess ENDP


TlsAlloc PROC
	mov eax,0FFFFFFFFh
	ret
TlsAlloc ENDP


TlsFree PROC dwTlsIndex:DWORD
	xor eax,eax
	ret
TlsFree ENDP


TlsGetValue PROC dwTlsIndex:DWORD
	xor eax,eax
	ret
TlsGetValue ENDP


TlsSetValue PROC dwTlsIndex:DWORD,lpTlsValue:DWORD
	xor eax,eax
	ret
TlsSetValue ENDP


GetFileType PROC hFile:DWORD
	mov eax,FILE_TYPE_UNKNOWN
	ret
GetFileType ENDP


SetHandleCount PROC uNumber:DWORD
	mov eax,uNumber
	ret
SetHandleCount ENDP


DeleteCriticalSection PROC lpCriticalSection:DWORD
	xor eax,eax
	ret
DeleteCriticalSection ENDP


GetEnvironmentStringsW PROC
	mov eax,OFFSET dummyString
	ret
GetEnvironmentStringsW ENDP


GetEnvironmentStrings PROC
	mov eax,OFFSET dummyString
	ret
GetEnvironmentStrings ENDP


FreeEnvironmentStringsA PROC lpzEnvironmentBlock:DWORD
	xor eax,eax
	ret
FreeEnvironmentStringsA ENDP
	

FreeEnvironmentStringsW PROC lpzEnvironmentBlock:DWORD
	xor eax,eax
	ret
FreeEnvironmentStringsW ENDP


WideCharToMultiByte PROC CodePage:DWORD,dwFlags:DWORD,lpWideCharString:DWORD,cchWideChar:DWORD,
		         lpMultiByteString:DWORD,cchMultiByte:DWORD,lpDefaultChar:DWORD,lpUsedDefaultChar:DWORD
	xor eax,eax
	ret
WideCharToMultiByte ENDP


HeapCreate PROC flOptions:DWORD,dwInitialSize:DWORD,dwMaximumSize:DWORD
	xor eax,eax
	ret
HeapCreate ENDP


HeapDestroy PROC hHeap:DWORD
	xor eax,eax
	ret
HeapDestroy ENDP


HeapFree PROC hHeap:DWORD,dwFlags:DWORD,lpMem:DWORD
	xor eax,eax
	ret
HeapFree ENDP


VirtualFree PROC lpAddress:DWORD,dwSize:DWORD,dwFreeType:DWORD
	xor eax,eax
	ret
VirtualFree ENDP


WriteFile PROC hFile:DWORD,lpBuffer:DWORD,nNumberOfBytesToWrite:DWORD,lpNumberOfBytesWritten:DWORD,lpOverlapped:DWORD
	xor eax,eax
	ret
WriteFile ENDP


InitializeCriticalSection PROC lpCriticalSection:DWORD
	xor eax,eax
	ret
InitializeCriticalSection ENDP


EnterCriticalSection PROC lpCriticalSection:DWORD
	xor eax,eax
	ret
EnterCriticalSection ENDP


LeaveCriticalSection PROC lpCriticalSection:DWORD
	xor eax,eax
	ret
LeaveCriticalSection ENDP


HeapAlloc PROC hHeap:DWORD,dwFlags:DWORD,dwBytes:DWORD
	xor eax,eax
	ret
HeapAlloc ENDP


GetCPInfo PROC CodePage:DWORD,lpCPInfo:DWORD
	xor eax,eax
	ret
GetCPInfo ENDP


GetACP PROC 
	mov eax,1252			; Win 3.1 US/Western European ANSI Code Page
	ret
GetACP ENDP


GetOEMCP PROC
	mov eax,437			; US MS-DOS
	ret
GetOEMCP ENDP


VirtualAlloc PROC lpAddress:DWORD,dwSize:DWORD,flAllocationType:DWORD,flProtect:DWORD
	xor eax,eax
	ret
VirtualAlloc ENDP


HeapReAlloc PROC hHeap:DWORD,dwFlags:DWORD,lpMem:DWORD,dwBytes:DWORD
	xor eax,eax
	ret
HeapReAlloc ENDP


LCMapStringA PROC Locale:DWORD,dwMapFlags:DWORD,lpSrcStr:DWORD,cchSrc:DWORD,lpDestStr:DWORD,cchDest:DWORD
	xor eax,eax
	ret
LCMapStringA ENDP


LCMapStringW PROC Locale:DWORD,dwMapFlags:DWORD,lpSrcStr:DWORD,cchSrc:DWORD,lpDestStr:DWORD,cchDest:DWORD
	xor eax,eax
	ret
LCMapStringW ENDP


GetStringTypeA PROC Locale:DWORD,dwInfoType:DWORD,lpSrcStr:DWORD,cchSrc:DWORD,lpCharType:DWORD
	xor eax,eax
	ret
GetStringTypeA ENDP


GetStringTypeW PROC Locale:DWORD,dwInfoType:DWORD,lpSrcStr:DWORD,cchSrc:DWORD,lpCharType:DWORD
	xor eax,eax
	ret
GetStringTypeW ENDP


RtlUnwind PROC
	xor eax,eax
	ret
RtlUnwind ENDP


; ##########################################################################

End LibMain
